LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;
USE ieee.std_logic_arith.all;
USE std.standard.all;
USE work.JH_256_paket.all;


ENTITY JH_256 IS
 PORT
	(
		reset, clk, first_block, last_block: IN STD_LOGIC; 
		message_block: IN STD_LOGIC_VECTOR(511 DOWNTO 0); 	
		receive_ready, get_hash, init_done : OUT STD_LOGIC;
		hashvalue: OUT STD_LOGIC_VECTOR(255 DOWNTO 0) 		
	);
END JH_256;

ARCHITECTURE JH_algorithm OF JH_256 IS

	 SIGNAL state_automat:final_automat; 
	 SIGNAL brojac: INTEGER;
	 SIGNAL message_block_internal: STD_LOGIC_VECTOR(511 DOWNTO 0);
	 SIGNAL flag: STD_LOGIC;

BEGIN
	
	PROCESS(reset,clk)	

		VARIABLE H: hash_type;	 
		VARIABLE roundconstant:round_zero_type;		
		VARIABLE Q: round_type;	
		VARIABLE hash_final: STD_LOGIC_VECTOR (255 DOWNTO 0);
		
	 BEGIN
	  
		IF (reset='1')THEN	
		state_automat<= init;		
		flag<='0';
		get_hash<='0';
		init_done<='0';
		receive_ready<='0';
		hashvalue<=(OTHERS=>'0'); 			
		ELSIF (clk'EVENT AND clk='1') THEN		
				CASE (state_automat) IS	
					WHEN init =>
						get_hash<='0';
						hash_initial(H,Q); 
						roundconstant_expanded_func(roundconstant); 
						state_automat<=round_init;
						brojac<=0;	
						receive_ready<='0';
					WHEN round_init =>
						r8(roundconstant,Q); 
						update_roundconstant(roundconstant); 
						brojac<=brojac+1;
						IF (brojac>40) THEN 
							f8_reverse(Q,H); 
							state_automat<= idle;						
							init_done<='1';
						ELSE
							state_automat<= processing_init;
							init_done<='0';
						END IF;
					WHEN processing_init =>	
						state_automat<= round_init; 
					WHEN idle =>		
						get_hash<='0';
						receive_ready<='1'; 
						IF (first_block='1') THEN 						
							brojac<=0;
							message_block_internal<=message_block;
							roundconstant_expanded_func(roundconstant);
							hash_calculate(message_block, H, Q); 
							state_automat<= round;
							receive_ready<='0';							
							IF(last_block='1')THEN 
								flag<='1';
							ELSE															
								flag<='0'; 
							END IF;	
						END IF;
					WHEN round =>
						r8(roundconstant,Q);
						update_roundconstant(roundconstant);
						receive_ready<='0';
						brojac<=brojac+1;
						IF (brojac>40) THEN 
							IF(flag='1')THEN
								hash_calculate_reverse(message_block, Q, H); 
								state_automat<= finalization;							
							ELSE
								state_automat<= processing;
							END IF;
						ELSE
							state_automat<= processing_round;
						END IF;
					WHEN processing_round =>	
						state_automat<= round;						
					WHEN processing =>						
						message_block_internal<=message_block;
						hash_calculate_reverse(message_block_internal, Q, H); 
						roundconstant_expanded_func(roundconstant);
						receive_ready<='1';
						brojac<=0;				
						hash_calculate(message_block, H, Q); 
						state_automat<= round;							
						IF(last_block='1')THEN 
							flag<='1';
						ELSE															
							flag<='0'; 
						END IF;	
					WHEN finalization =>	
						get_hash<='1';
						message_block_internal<=message_block;
						hash_final_func(H,hash_final);
						hashvalue<=hash_final;
						state_automat<= init;
						receive_ready<='0';
				END CASE;
		END IF;	
	END PROCESS;	

END JH_algorithm;
