--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   23:20:49 05/18/2015
-- Design Name:   
-- Module Name:   C:/Xilinx/Final/JH256/test256.vhd
-- Project Name:  JH256
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: JH_256
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
 
-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--USE ieee.numeric_std.ALL;
 
ENTITY test256 IS
END test256;
 
ARCHITECTURE behavior OF test256 IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT JH_256
    PORT(
         reset : IN  std_logic;
         clk : IN  std_logic;
         first_block : IN  std_logic;
         last_block : IN  std_logic;
         message_block : IN  std_logic_vector(511 downto 0);
         receive_ready : OUT  std_logic;
         get_hash : OUT  std_logic;
         init_done : OUT  std_logic;
         hashvalue : OUT  std_logic_vector(255 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal reset : std_logic := '0';
   signal clk : std_logic := '0';
   signal first_block : std_logic := '0';
   signal last_block : std_logic := '0';
   signal message_block : std_logic_vector(511 downto 0) := (others => '0');

 	--Outputs
   signal receive_ready : std_logic;
   signal get_hash : std_logic;
   signal init_done : std_logic;
   signal hashvalue : std_logic_vector(255 downto 0);

   -- Clock period definitions
   constant clk_period : time := 10 ns;
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: JH_256 PORT MAP (
          reset => reset,
          clk => clk,
          first_block => first_block,
          last_block => last_block,
          message_block => message_block,
          receive_ready => receive_ready,
          get_hash => get_hash,
          init_done => init_done,
          hashvalue => hashvalue
        );

 -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 

	process --reset
   begin		
		
		reset<='1';
		wait for 10 ns;	
		loop
			reset<='0';
			wait for 10 ns;	
		end loop;	
   end process;
	
	
process 
	begin
	first_block<='0';
	last_block<='0';
	wait for 900 ns;
	message_block(511 downto 0)<=X"BE913DB05D76C1296BE7F5B44C96173C6D90FBAB8E3FFA1417E185EB806D45B268FF37C70E2C5EED422ADCA1DB885B808AB7D855C5391FC0118AC127EB4E42FC";
	--message_block(511 DOWNTO 8)<=(OTHERS=>'0');
	first_block<='1';
	last_block<='0';
	wait for 10 ns;
	message_block(511 DOWNTO 24)<=(OTHERS=>'0');
	message_block(23 downto 0)<=X"80FC37";
	first_block<='0';
	last_block<='0'; 
	wait for 900 ns;
	message_block(497 DOWNTO 0)<=(OTHERS=>'0');
	message_block(511 downto 496)<=X"1002";
	first_block<='0';
	last_block<='1';  

	wait for 1000 ns;
		
		
	first_block<='0';
	last_block<='0';
	wait for 900 ns;
	message_block(7 downto 0)<=X"80";
	message_block(511 DOWNTO 8)<=(OTHERS=>'0');
	first_block<='1';
	last_block<='1';
	
	loop
	wait for 10ns;
	end loop;
	end process;
END;